diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 224dccb2c..4a0dfa662 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -5,14 +5,16 @@ import static org.lwjgl.opengl.GL11.*;
 import java.util.List;
 import java.util.Random;
 
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.phys.Vec3;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.util.glu.GLU;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityRainFX;
-import net.minecraft.client.entity.fx.EntitySmokeFX;
-import net.minecraft.client.entity.player.EntityPlayerSP;
+import net.minecraft.client.entity.particle.WaterDropParticle;
+import net.minecraft.client.entity.particle.SmokeParticle;
+import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.client.gui.GuiPhotoMode;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.input.InputType;
@@ -27,22 +29,20 @@ import net.minecraft.client.render.camera.EntityCameraThirdPersonFront;
 import net.minecraft.client.render.camera.EntityCameraThirdPersonRear;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.culling.Frustum;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.window.GameWindowLWJGL2;
 import net.minecraft.client.util.debug.Debug;
 import net.minecraft.client.world.chunk.provider.ChunkProviderStatic;
-import net.minecraft.core.HitResult;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Time;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
@@ -109,7 +109,7 @@ public class WorldRenderer
 
     private void updateSpeedFov()
     {
-        EntityPlayerSP player = mc.thePlayer;
+        LocalPlayer player = mc.thePlayer;
         currentFovModifier = player.getFovModifier();
         a = b;
         b += (currentFovModifier - b) * 0.5f;
@@ -126,9 +126,9 @@ public class WorldRenderer
 		final double blockReach = mc.playerController.getBlockReachDistance();
 		final double entityReach = mc.playerController.getEntityReachDistance();
 		
-		Vec3d pos1 = mc.thePlayer.getPosition(partialTicks);
-		Vec3d look = mc.thePlayer.getViewVector(partialTicks);
-		Vec3d pos2 = pos1.addVector(look.xCoord * blockReach, look.yCoord * blockReach, look.zCoord * blockReach);
+		Vec3 pos1 = mc.thePlayer.getPosition(partialTicks);
+		Vec3 look = mc.thePlayer.getViewVector(partialTicks);
+		Vec3 pos2 = pos1.add(look.x * blockReach, look.y * blockReach, look.z * blockReach);
 		
 		// Raytrace blocks
 		mc.objectMouseOver = mc.theWorld.checkBlockCollisionBetweenPoints(pos1, pos2);
@@ -136,7 +136,7 @@ public class WorldRenderer
 		// Calculate again because block raytrace changes the values
 		pos1 = mc.thePlayer.getPosition(partialTicks);
 		look = mc.thePlayer.getViewVector(partialTicks);
-		pos2 = pos1.addVector(look.xCoord * entityReach, look.yCoord * entityReach, look.zCoord * entityReach);
+		pos2 = pos1.add(look.x * entityReach, look.y * entityReach, look.z * entityReach);
 		
 		double hitBlockDistance = 1000.0;
 		if(mc.objectMouseOver != null) {
@@ -145,7 +145,7 @@ public class WorldRenderer
 		
 		this.pointedEntity = null;
 		float expand = 1.0f;
-		AABB entitySearchBox = mc.thePlayer.bb.addCoord(look.xCoord * entityReach, look.yCoord * entityReach, look.zCoord * entityReach).expand(expand, expand, expand);
+		AABB entitySearchBox = mc.thePlayer.bb.expand(look.x * entityReach, look.y * entityReach, look.z * entityReach).grow(expand, expand, expand);
 		
 		List<Entity> entities = mc.theWorld.getEntitiesWithinAABBExcludingEntity(mc.thePlayer, entitySearchBox);
 		
@@ -158,15 +158,15 @@ public class WorldRenderer
 			}
 			
 			float hitRadius = entity.getPickRadius();
-			AABB hitBox = entity.bb.expand(hitRadius, hitRadius, hitRadius);
+			AABB hitBox = entity.bb.grow(hitRadius, hitRadius, hitRadius);
 			
-			if(hitBox.isVecInside(pos1)) {
+			if(hitBox.contains(pos1)) {
 				this.pointedEntity = entity;
 				pointedEntityDistance = 0.0;
 				continue;
 			}
 			
-			HitResult hitResult = hitBox.func_1169_a(pos1, pos2);
+			HitResult hitResult = hitBox.clip(pos1, pos2);
 			if(hitResult == null) {
 				continue;
 			}
@@ -191,10 +191,10 @@ public class WorldRenderer
 
     private float getFOVModifier(float partialTick, boolean isModifiedByFOV)
     {
-        EntityLiving entityliving = null;
+        Mob entityliving = null;
         if (mc.activeCamera instanceof EntityCamera)
         {
-            entityliving = ((EntityCamera) mc.activeCamera).entity;
+            entityliving = ((EntityCamera) mc.activeCamera).mob;
         }
         float f1 = 70f;
         if(isModifiedByFOV)
@@ -217,7 +217,7 @@ public class WorldRenderer
     private void hurtCameraEffect(float partialTick)
     {
         if (!(mc.activeCamera instanceof EntityCamera)) return;
-        EntityLiving entityliving = ((EntityCamera) mc.activeCamera).entity;
+        Mob entityliving = ((EntityCamera) mc.activeCamera).mob;
         float f1 = (float)entityliving.hurtTime - partialTick;
         if(entityliving.getHealth() <= 0)
         {
@@ -230,7 +230,7 @@ public class WorldRenderer
         } else
         {
             f1 /= entityliving.maxHurtTime;
-            f1 = MathHelper.sin(f1 * f1 * f1 * f1 * 3.141593F);
+            f1 = MathHelper.sin(f1 * f1 * f1 * f1 * MathHelper.PI);
             float f3 = entityliving.attackedAtYaw;
             glRotatef(-f3, 0.0F, 1.0F, 0.0F);
             glRotatef(-f1 * 14F, 0.0F, 0.0F, 1.0F);
@@ -241,9 +241,9 @@ public class WorldRenderer
 
     private void setupViewBobbing(float partialTick)
     {
-        if (mc.activeCamera instanceof EntityCamera && ((EntityCamera) mc.activeCamera).entity instanceof EntityPlayer)
+        if (mc.activeCamera instanceof EntityCamera && ((EntityCamera) mc.activeCamera).mob instanceof Player)
         {
-            EntityPlayer player = (EntityPlayer)((EntityCamera) mc.activeCamera).entity;
+            Player player = (Player)((EntityCamera) mc.activeCamera).mob;
             float walkDist = -MathHelper.lerp(player.walkDistO, player.walkDist, partialTick);
             float cameraVel = MathHelper.lerp(player.cameraVelocityOld, player.cameraVelocity, partialTick);
             float cameraPitch = MathHelper.lerp(player.prevCameraPitch, player.cameraPitch, partialTick);
@@ -262,7 +262,7 @@ public class WorldRenderer
     {
         if (mc.activeCamera instanceof EntityCamera)
         {
-            EntityLiving entityliving = ((EntityCamera) mc.activeCamera).entity;
+            Mob entityliving = ((EntityCamera) mc.activeCamera).mob;
             if (mc.currentScreen instanceof GuiPhotoMode)
             {
                 mc.activeCamera = new EntityCameraIsometric(mc, entityliving);
@@ -272,7 +272,7 @@ public class WorldRenderer
                 if (!(mc.activeCamera instanceof EntityCameraSleeping))
                 {
                     mc.activeCamera = new EntityCameraSleeping(mc, entityliving,
-                            MathHelper.floor_double(entityliving.x), MathHelper.floor_double(entityliving.y), MathHelper.floor_double(entityliving.z),
+                            MathHelper.floor(entityliving.x), MathHelper.floor(entityliving.y), MathHelper.floor(entityliving.z),
                             mc.activeCamera.getX(partialTick), mc.activeCamera.getY(partialTick), mc.activeCamera.getZ(partialTick), mc.activeCamera.getYRot(partialTick), mc.activeCamera.getXRot(partialTick)
                     );
                 }
@@ -375,7 +375,7 @@ public class WorldRenderer
         {
             setupViewBobbing(partialTick);
         }
-        if(mc.gameSettings.thirdPersonView.value == 0 && !(mc.currentScreen instanceof GuiPhotoMode) && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).entity.isPlayerSleeping()) && mc.gameSettings.immersiveMode.drawHand())
+        if(mc.gameSettings.thirdPersonView.value == 0 && !(mc.currentScreen instanceof GuiPhotoMode) && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).mob.isPlayerSleeping()) && mc.gameSettings.immersiveMode.drawHand())
         {
             lightmapHelper.enableLightmapRendering();
             if(!zooming) itemRenderer.renderItemInFirstPerson(partialTick);
@@ -386,7 +386,7 @@ public class WorldRenderer
         Debug.change("post");
         mc.renderer.endRenderWorld(partialTick);
         
-        if(mc.gameSettings.thirdPersonView.value == 0 && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).entity.isPlayerSleeping()))
+        if(mc.gameSettings.thirdPersonView.value == 0 && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).mob.isPlayerSleeping()))
         {
             itemRenderer.renderOverlays(partialTick);
             hurtCameraEffect(partialTick);
@@ -399,7 +399,7 @@ public class WorldRenderer
     private float getZoomedFOV(float currentFov, float partialTick){
         currentFov *= 0.45f;
         float prevZoomProgress = zoomProgress;
-        zoomProgress -= Mouse.getDWheel()/256f;
+        zoomProgress -= Mouse.getDWheel()/0.256f;
         zoomProgress = MathHelper.clamp(zoomProgress, -7.5f, 7.5f);
         final float maxFOV = 160f;
         final float minFOV = 5f;
@@ -595,10 +595,10 @@ public class WorldRenderer
             mc.activeCamera = new EntityCameraFirstPerson(mc, mc.thePlayer);
         }
         getMouseOver(partialTick);
-        EntityLiving activeEntity = null;
+        Mob activeEntity = null;
         if (mc.activeCamera instanceof EntityCamera)
         {
-            activeEntity = ((EntityCamera)mc.activeCamera).entity;
+            activeEntity = ((EntityCamera)mc.activeCamera).mob;
         }
 
         if (activeEntity != null)
@@ -637,7 +637,7 @@ public class WorldRenderer
         fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
         if(mc.gameSettings.ambientOcclusion.value)
         {
-            glShadeModel(7425 /*GL_SMOOTH*/);
+            glShadeModel(GL11.GL_SMOOTH);
         }
         
         mc.renderGlobal.clipRenderersByFrustum(mc.activeCamera.getFrustum(), partialTick);
@@ -661,7 +661,7 @@ public class WorldRenderer
 
         fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
         glEnable(GL_FOG);
-        TextureRegistry.blockAtlas.bindTexture();
+        TextureRegistry.blockAtlas.bind();
         Lighting.disable();
 
         Debug.change("terrain");
@@ -712,7 +712,7 @@ public class WorldRenderer
         fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTick);
         glEnable(GL_BLEND);
         glDisable(GL_CULL_FACE);
-        TextureRegistry.blockAtlas.bindTexture();
+        TextureRegistry.blockAtlas.bind();
 
         Debug.change("water");
         if(mc.gameSettings.ambientOcclusion.value)
@@ -786,9 +786,9 @@ public class WorldRenderer
         }
         random.setSeed((long)rendererUpdateCount * 0x12a7ce5fL);
         World world = mc.theWorld;
-        int cameraX = MathHelper.floor_double(mc.activeCamera.getX());
-        int cameraY = MathHelper.floor_double(mc.activeCamera.getY());
-        int cameraZ = MathHelper.floor_double(mc.activeCamera.getZ());
+        int cameraX = MathHelper.floor(mc.activeCamera.getX());
+        int cameraY = MathHelper.floor(mc.activeCamera.getY());
+        int cameraZ = MathHelper.floor(mc.activeCamera.getZ());
         byte byte0 = 10;
         double d = 0.0D;
         double d1 = 0.0D;
@@ -820,7 +820,7 @@ public class WorldRenderer
             }
             if(Block.blocksList[i2].blockMaterial == Material.lava)
             {
-                mc.effectRenderer.addEffect(new EntitySmokeFX(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2, 0.0D, 0.0D, 0.0D));
+                mc.effectRenderer.addEffect(new SmokeParticle(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2, 0.0D, 0.0D, 0.0D));
                 continue;
             }
             if(random.nextInt(++l) == 0)
@@ -829,13 +829,13 @@ public class WorldRenderer
                 d1 = (double)((float)y + 0.1F) - Block.blocksList[i2].minY;
                 d2 = (float)randZ + f2;
             }
-            mc.effectRenderer.addEffect(new EntityRainFX(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2));
+            mc.effectRenderer.addEffect(new WaterDropParticle(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2));
         }
 
         if(l > 0 && random.nextInt(3) < rainSoundCounter++)
         {
             rainSoundCounter = 0;
-            if(d1 > mc.activeCamera.getY() + 1.0D && world.getHeightValue(MathHelper.floor_double(mc.activeCamera.getX()), MathHelper.floor_double(mc.activeCamera.getZ())) > MathHelper.floor_double(mc.activeCamera.getY()))
+            if(d1 > mc.activeCamera.getY() + 1.0D && world.getHeightValue(MathHelper.floor(mc.activeCamera.getX()), MathHelper.floor(mc.activeCamera.getZ())) > MathHelper.floor(mc.activeCamera.getY()))
             {
                 mc.theWorld.playSoundEffect(null, SoundCategory.WEATHER_SOUNDS, d, d1, d2, "ambient.weather.rain", 0.1F * mc.theWorld.weatherManager.getWeatherIntensity() * mc.theWorld.weatherManager.getWeatherPower() * 0.5f, 0.5F);
             } else
@@ -851,22 +851,22 @@ public class WorldRenderer
         if (weather == null || !weather.isPrecipitation) return;
         
         World world = mc.theWorld;
-        int posX = MathHelper.floor_double(mc.activeCamera.getX());
-        int posY = MathHelper.floor_double(mc.activeCamera.getY());
-        int posZ = MathHelper.floor_double(mc.activeCamera.getZ());
+        int posX = MathHelper.floor(mc.activeCamera.getX());
+        int posY = MathHelper.floor(mc.activeCamera.getY());
+        int posZ = MathHelper.floor(mc.activeCamera.getZ());
         Tessellator tessellator = Tessellator.instance;
-        glDisable(2884 /*GL_CULL_FACE*/);
+        glDisable(GL11.GL_CULL_FACE);
         glNormal3f(0.0F, 1.0F, 0.0F);
-        glEnable(3042 /*GL_BLEND*/);
+        glEnable(GL11.GL_BLEND);
         glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         glAlphaFunc(516, 0.01F);
-        
-        glBindTexture(3553 /*GL_TEXTURE_2D*/, mc.renderEngine.getTexture(weather.getPrecipitationTexture(world)));
+
+        mc.renderEngine.loadTexture(weather.getPrecipitationTexture(world)).bind();
         
         double nextPosX = mc.activeCamera.getX(partialTick);
         double nextPosY = mc.activeCamera.getY(partialTick);
         double nextPosZ = mc.activeCamera.getZ(partialTick);
-        int floorPosY = MathHelper.floor_double(nextPosY);
+        int floorPosY = MathHelper.floor(nextPosY);
         int radiusEffect = 10;
 
         if (weather.precipitationType == 1)
@@ -905,7 +905,7 @@ public class WorldRenderer
                         float f8 = random.nextFloat() + f5 * (float)random.nextGaussian() * 0.001F;
                         double d5 = (double)((float)x + 0.5F) - mc.activeCamera.getX();
                         double d6 = (double)((float)z + 0.5F) - mc.activeCamera.getZ();
-                        float f11 = MathHelper.sqrt_double(d5 * d5 + d6 * d6) / (float)radiusEffect;
+                        float f11 = MathHelper.sqrt(d5 * d5 + d6 * d6) / (float)radiusEffect;
                         tessellator.startDrawingQuads();
                         float f12 = world.getLightBrightness(x, i3, z);
                         if (mc.fullbright) f12 = 1.0f;
@@ -952,7 +952,7 @@ public class WorldRenderer
                         float f4 = (((float)(rendererUpdateCount + x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + random.nextFloat());
                         double d3 = (double)((float)x + 0.5F) - mc.activeCamera.getX();
                         double d4 = (double)((float)z + 0.5F) - mc.activeCamera.getZ();
-                        float f9 = MathHelper.sqrt_double(d3 * d3 + d4 * d4) / (float)radiusEffect;
+                        float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float)radiusEffect;
                         tessellator.startDrawingQuads();
                         float f10 = world.getLightBrightness(x, world.getHeightBlocks(), z) * 0.85F + 0.15F;
                         if (mc.fullbright) f10 = 1.0f;
@@ -1006,7 +1006,7 @@ public class WorldRenderer
                         float vOffset = (((float)(rendererUpdateCount + x * x * 3121 /*GL_RGBA_MODE*/ + x * 0x2b24abb + z * z * 0x66397 + z * 13761 & 0x1f) + partialTick) / 32F) * (3F + random.nextFloat());
                         double d3 = (double)((float)x + 0.5F) - mc.activeCamera.getX();
                         double d4 = (double)((float)z + 0.5F) - mc.activeCamera.getZ();
-                        float f9 = MathHelper.sqrt_double(d3 * d3 + d4 * d4) / (float)radiusEffect;
+                        float f9 = MathHelper.sqrt(d3 * d3 + d4 * d4) / (float)radiusEffect;
                         tessellator.startDrawingQuads();
                         float f10 = world.getLightBrightness(x, world.getHeightBlocks(), z) * 0.85F + 0.15F;
                         if (mc.fullbright) f10 = 1.0f;
@@ -1029,18 +1029,18 @@ public class WorldRenderer
         }
 
 
-        glEnable(2884 /*GL_CULL_FACE*/);
-        glDisable(3042 /*GL_BLEND*/);
+        glEnable(GL11.GL_CULL_FACE);
+        glDisable(GL11.GL_BLEND);
         glAlphaFunc(516, 0.1F);
     }
 
     public void setupScaledResolution()
     {
         glClear(256);
-        glMatrixMode(5889 /*GL_PROJECTION*/);
+        glMatrixMode(GL11.GL_PROJECTION);
         glLoadIdentity();
         glOrtho(0.0D, mc.resolution.scaledWidthExact, mc.resolution.scaledHeightExact, 0.0D, 1000D, 3000D);
-        glMatrixMode(5888 /*GL_MODELVIEW0_ARB*/);
+        glMatrixMode(GL11.GL_MODELVIEW);
         glLoadIdentity();
         glTranslatef(0.0F, 0.0F, -2000F);
     }
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index 79b263d9c..0c4865e08 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -3,12 +3,13 @@ package net.minecraft.client.render.block.color;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 
 public final class BlockColorDispatcher
     extends Dispatcher<Block, BlockColor>
 {
     private static final BlockColorDispatcher instance = new BlockColorDispatcher();
-    private static final BlockColor defaultColor = new BlockColorDefault();
+    private static final BlockColor defaultColor = new DefaultBlockColor();
 
     public static BlockColorDispatcher getInstance()
     {
@@ -17,28 +18,28 @@ public final class BlockColorDispatcher
 
     private BlockColorDispatcher()
     {
-        addDispatch(Block.algae, new BlockColorCustom(Colorizers.grass));
-        addDispatch(Block.fluidWaterStill, new BlockColorWater(Colorizers.water));
-        addDispatch(Block.fluidWaterFlowing, new BlockColorWater(Colorizers.water));
-        addDispatch(Block.grass, new BlockColorCustom(Colorizers.grass));
-        addDispatch(Block.layerLeavesOak, new BlockColorCustom(Colorizers.oak));
-        addDispatch(Block.leavesBirch, new BlockColorCustom(Colorizers.birch));
-        addDispatch(Block.leavesCherry, new BlockColorCustom(Colorizers.cherry));
-        addDispatch(Block.leavesCherryFlowering, new BlockColorCustom(Colorizers.cherry));
-        addDispatch(Block.leavesEucalyptus, new BlockColorCustom(Colorizers.eucalyptus));
-        addDispatch(Block.leavesCacao, new BlockColorCustom(Colorizers.cacao));
-        addDispatch(Block.leavesOak, new BlockColorCustom(Colorizers.oak));
-        addDispatch(Block.leavesPine, new BlockColorCustom(Colorizers.pine));
-        addDispatch(Block.leavesShrub, new BlockColorCustom(Colorizers.shrub));
-        addDispatch(Block.leavesThorn, new BlockColorCustom(Colorizers.thorn));
-        addDispatch(Block.leavesPalm, new BlockColorCustom(Colorizers.palm));
-        addDispatch(Block.mossStone, new BlockColorCustom(Colorizers.grass));
-        addDispatch(Block.mossBasalt, new BlockColorCustom(Colorizers.grass));
-        addDispatch(Block.mossLimestone, new BlockColorCustom(Colorizers.grass));
-        addDispatch(Block.mossGranite, new BlockColorCustom(Colorizers.grass));
-        addDispatch(Block.wireRedstone, new BlockColorRedstoneWire());
-        addDispatch(Block.tallgrass, new BlockColorCustom(Colorizers.grass));
-        addDispatch(Block.tallgrassFern, new BlockColorCustom(Colorizers.grass));
+        addDispatch(Blocks.ALGAE, new CustomBlockColor(Colorizers.grass));
+        addDispatch(Blocks.FLUID_WATER_STILL, new WaterBlockColor(Colorizers.water));
+        addDispatch(Blocks.FLUID_WATER_FLOWING, new WaterBlockColor(Colorizers.water));
+        addDispatch(Blocks.GRASS, new CustomBlockColor(Colorizers.grass));
+        addDispatch(Blocks.LAYER_LEAVES_OAK, new CustomBlockColor(Colorizers.oak));
+        addDispatch(Blocks.LEAVES_BIRCH, new CustomBlockColor(Colorizers.birch));
+        addDispatch(Blocks.LEAVES_CHERRY, new CustomBlockColor(Colorizers.cherry));
+        addDispatch(Blocks.LEAVES_CHERRY_FLOWERING, new CustomBlockColor(Colorizers.cherry));
+        addDispatch(Blocks.LEAVES_EUCALYPTUS, new CustomBlockColor(Colorizers.eucalyptus));
+        addDispatch(Blocks.LEAVES_CACAO, new CustomBlockColor(Colorizers.cacao));
+        addDispatch(Blocks.LEAVES_OAK, new CustomBlockColor(Colorizers.oak));
+        addDispatch(Blocks.LEAVES_PINE, new CustomBlockColor(Colorizers.pine));
+        addDispatch(Blocks.LEAVES_SHRUB, new CustomBlockColor(Colorizers.shrub));
+        addDispatch(Blocks.LEAVES_THORN, new CustomBlockColor(Colorizers.thorn));
+        addDispatch(Blocks.LEAVES_PALM, new CustomBlockColor(Colorizers.palm));
+        addDispatch(Blocks.MOSS_STONE, new CustomBlockColor(Colorizers.grass));
+        addDispatch(Blocks.MOSS_BASALT, new CustomBlockColor(Colorizers.grass));
+        addDispatch(Blocks.MOSS_LIMESTONE, new CustomBlockColor(Colorizers.grass));
+        addDispatch(Blocks.MOSS_GRANITE, new CustomBlockColor(Colorizers.grass));
+        addDispatch(Blocks.WIRE_REDSTONE, new RedstoneWireBlockColor());
+        addDispatch(Blocks.TALLGRASS, new CustomBlockColor(Colorizers.grass));
+        addDispatch(Blocks.TALLGRASS_FERN, new CustomBlockColor(Colorizers.grass));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java b/src/main/java/net/minecraft/client/render/block/color/CustomBlockColor.java
similarity index 84%
rename from src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
rename to src/main/java/net/minecraft/client/render/block/color/CustomBlockColor.java
index a0fcdb374..76d4a3c27 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorCustom.java
+++ b/src/main/java/net/minecraft/client/render/block/color/CustomBlockColor.java
@@ -3,11 +3,11 @@ package net.minecraft.client.render.block.color;
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockColorCustom extends BlockColor {
+public class CustomBlockColor extends BlockColor {
 
 	public Colorizer colorizer;
 	
-	public BlockColorCustom(Colorizer colorizer) {
+	public CustomBlockColor(Colorizer colorizer) {
 		this.colorizer = colorizer;
 		
 		if(colorizer == null) {
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java b/src/main/java/net/minecraft/client/render/block/color/DefaultBlockColor.java
similarity index 87%
rename from src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
rename to src/main/java/net/minecraft/client/render/block/color/DefaultBlockColor.java
index ce2dd08ae..cf5117ea0 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorDefault.java
+++ b/src/main/java/net/minecraft/client/render/block/color/DefaultBlockColor.java
@@ -1,19 +1,19 @@
-package net.minecraft.client.render.block.color;
-
-import net.minecraft.core.world.WorldSource;
-
-public class BlockColorDefault
-    extends BlockColor
-{
-    @Override
-    public int getFallbackColor(int meta)
-    {
-        return 0xFFFFFF;
-    }
-
-    @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z)
-    {
-        return 0xFFFFFF;
-    }
-}
+package net.minecraft.client.render.block.color;
+
+import net.minecraft.core.world.WorldSource;
+
+public class DefaultBlockColor
+    extends BlockColor
+{
+    @Override
+    public int getFallbackColor(int meta)
+    {
+        return 0xFFFFFF;
+    }
+
+    @Override
+    public int getWorldColor(WorldSource world, int x, int y, int z)
+    {
+        return 0xFFFFFF;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java b/src/main/java/net/minecraft/client/render/block/color/LeavesOakBlockColor.java
similarity index 89%
rename from src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
rename to src/main/java/net/minecraft/client/render/block/color/LeavesOakBlockColor.java
index 4191dae30..d00e842c1 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorLeavesOak.java
+++ b/src/main/java/net/minecraft/client/render/block/color/LeavesOakBlockColor.java
@@ -1,42 +1,42 @@
-package net.minecraft.client.render.block.color;
-
-import java.util.Random;
-
-import net.minecraft.client.render.colorizer.Colorizer;
-import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.noise.ImprovedNoise;
-import net.minecraft.core.world.season.Season;
-import net.minecraft.core.world.season.Seasons;
-
-public class BlockColorLeavesOak extends BlockColorCustom {
-	
-	private static ImprovedNoise fallColorPerlin = new ImprovedNoise(new Random(0));
-	
-	public BlockColorLeavesOak(Colorizer colorizer) {
-		super(colorizer);
-	}
-	
-	@Override
-	public int getWorldColor(WorldSource world, int x, int y, int z) {
-		int color = super.getWorldColor(world, x, y, z);
-		
-		Season season = world.getSeasonManager().getCurrentSeason();
-		if(season != null) {
-			float progress = world.getSeasonManager().getSeasonProgress();
-			if(season == Seasons.OVERWORLD_FALL) {
-				float offsetIntensity = 1 - Math.abs((progress * 2) - 1);
-				float green = ((color & 0x00FF00) >> 8) / 255F;
-				float greenOffset = (float) fallColorPerlin.getValue(x / 10D, y / 10D, z / 10D) * offsetIntensity * 0.5f;
-				if(green + greenOffset > 0.8f)
-					greenOffset = 0.8f - green;
-				if(green + greenOffset < 0.0f)
-					greenOffset = -green;
-				int newGreen = ((int) ((green + greenOffset) * 255)) & 0xFF;
-				color &= 0xFF00FF;
-				color |= (newGreen << 8);
-			}
-		}
-		
-		return color;
-	}
-}
+package net.minecraft.client.render.block.color;
+
+import java.util.Random;
+
+import net.minecraft.client.render.colorizer.Colorizer;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.noise.ImprovedNoise;
+import net.minecraft.core.world.season.Season;
+import net.minecraft.core.world.season.Seasons;
+
+public class LeavesOakBlockColor extends CustomBlockColor {
+	
+	private static ImprovedNoise fallColorPerlin = new ImprovedNoise(new Random(0));
+	
+	public LeavesOakBlockColor(Colorizer colorizer) {
+		super(colorizer);
+	}
+	
+	@Override
+	public int getWorldColor(WorldSource world, int x, int y, int z) {
+		int color = super.getWorldColor(world, x, y, z);
+		
+		Season season = world.getSeasonManager().getCurrentSeason();
+		if(season != null) {
+			float progress = world.getSeasonManager().getSeasonProgress();
+			if(season == Seasons.OVERWORLD_FALL) {
+				float offsetIntensity = 1 - Math.abs((progress * 2) - 1);
+				float green = ((color & 0x00FF00) >> 8) / 255F;
+				float greenOffset = (float) fallColorPerlin.getValue(x / 10D, y / 10D, z / 10D) * offsetIntensity * 0.5f;
+				if(green + greenOffset > 0.8f)
+					greenOffset = 0.8f - green;
+				if(green + greenOffset < 0.0f)
+					greenOffset = -green;
+				int newGreen = ((int) ((green + greenOffset) * 255)) & 0xFF;
+				color &= 0xFF00FF;
+				color |= (newGreen << 8);
+			}
+		}
+		
+		return color;
+	}
+}
diff --git a/src/main/java/net/minecraft/client/render/block/color/BlockColorRedstoneWire.java b/src/main/java/net/minecraft/client/render/block/color/RedstoneWireBlockColor.java
similarity index 89%
rename from src/main/java/net/minecraft/client/render/block/color/BlockColorRedstoneWire.java
rename to src/main/java/net/minecraft/client/render/block/color/RedstoneWireBlockColor.java
index 6aabcc46e..af73cfbd8 100644
--- a/src/main/java/net/minecraft/client/render/block/color/BlockColorRedstoneWire.java
+++ b/src/main/java/net/minecraft/client/render/block/color/RedstoneWireBlockColor.java
@@ -1,22 +1,22 @@
-package net.minecraft.client.render.block.color;
-
-import net.minecraft.client.util.helper.Colors;
-import net.minecraft.core.world.WorldSource;
-
-public class BlockColorRedstoneWire
-    extends BlockColor
-{
-
-    @Override
-    public int getFallbackColor(int meta)
-    {
-        return Colors.allRedstoneColors[15].getARGB();
-    }
-
-    @Override
-    public int getWorldColor(WorldSource world, int x, int y, int z)
-    {
-        // Colored by renderer
-    	return Colors.allRedstoneColors[15].getARGB();
-    }
-}
+package net.minecraft.client.render.block.color;
+
+import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.world.WorldSource;
+
+public class RedstoneWireBlockColor
+    extends BlockColor
+{
+
+    @Override
+    public int getFallbackColor(int meta)
+    {
+        return Colors.allRedstoneColors[15].getARGB();
+    }
+
+    @Override
+    public int getWorldColor(WorldSource world, int x, int y, int z)
+    {
+        // Colored by renderer
+    	return Colors.allRedstoneColors[15].getARGB();
+    }
+}
